#include <io.h>
#include "x1.h"
#include "x1_psg.h"
#include "sndmsdos.h"

/**********************************************************************
	orf
**********************************************************************/

short psg_ini_at(void)
{
	if(!InitSound(1)) return 1;

	SetSound(0,SND_MELODIC);
	SetSound(1,SND_MELODIC);
	SetSound(2,SND_MELODIC);
	SetSound(3,SND_NOISE);

	return 0;
}

void psg_end_at(void)
{
	TrashSound();
}

byte psg_sta_at(void){ return 0xff; }

void psg_reg_at(byte V){}

word freq_fnc(byte h,byte l)
{
	word freq;

	freq =(word)h; freq<<=8;
	freq|=(word)l;
	if(!freq) return 1;

	return (word)(124800l/(long)freq);
}

short FRQ0=0;
short FRQ1=0;
short FRQ2=0;

void psg_dat_at(byte V)
{
	switch(PSG_ADR){
		case 0: FRQ0|=1; break;
		case 1: FRQ0|=2; break;
		case 2: FRQ1|=1; break;
		case 3: FRQ1|=2; break;
		case 4: FRQ2|=1; break;
		case 5: FRQ2|=2; break;
		case 7:
			if(V&1) SetVolume(0,0); else SetVolume(0,15*(int)(PSG_VAL[ 8]&15));
			if(V&2) SetVolume(1,0); else SetVolume(1,15*(int)(PSG_VAL[ 9]&15));
			if(V&4) SetVolume(2,0); else SetVolume(2,15*(int)(PSG_VAL[10]&15));
		break;
		case  8: SetVolume(0,15*(int)(PSG_VAL[ 8]&15)); break;
		case  9: SetVolume(1,15*(int)(PSG_VAL[ 9]&15)); break;
		case 10: SetVolume(2,15*(int)(PSG_VAL[10]&15)); break;
	}
	if(FRQ0==3){ FRQ0=0; SetFreq(0,freq_fnc(PSG_VAL[1],PSG_VAL[0])); }
	if(FRQ1==3){ FRQ1=0; SetFreq(1,freq_fnc(PSG_VAL[3],PSG_VAL[2])); }
	if(FRQ2==3){ FRQ2=0; SetFreq(2,freq_fnc(PSG_VAL[5],PSG_VAL[4])); }
}

