/***********************************************************************
	Qctbs[̃C[Wt@C쐬
------------------------------------------------------------------------
	̃\[XXg͂lrbpł
	cl /Zp /Gs make2d.c
------------------------------------------------------------------------

	| DA   |  UA  |
	7 6 5 4 3 2 1 0
	| |---|     |-|
  |   |        | 
  |   |        |--- Unit-No.
  |   |------------ 0=HDD 1=1MB 7=640K
  |---------------- 0=DD  1=HD

  0x50-0x53 320K byte FDD 
  0x70-0x73 640K byte FDD 
  0x80-0x83 SASI HDD      
  0x90-0x93 1M   Byte FDD 
  0xA0-0xA7 SCSI HDD      
  0xE?      RAM DISK      

2D  40trk 16sec  256byte  320Kbyte (X1)
    40trk  9sec  512byte  360Kbyte
    40trk  5sec 1024byte  400Kbyte
2DD 80trk 16sec  256byte  640Kbyte
    80trk  9sec  512byte  720Kbyte
    80trk  5sec 1024byte  800Kbyte
2HD 77trk 26sec  256byte 1001Kbyte
    77trk 15sec  512byte 1155Kbyte
    77trk  8sec 1024byte 1232Kbyte (PC98)

***********************************************************************/

#include <stdio.h>
#include <dos.h>

struct FDD_PARA {
	unsigned char n; /*   0=128 1=256 2=512 3=1024 */
	unsigned char c; /* No. 0-76 */
	unsigned char h; /* ͯ     0-1  */
	unsigned char r; /* No.   1-26 */
};

short BiosRead(short cmnd,short daua,struct FDD_PARA *para,void far *buff)
{
	unsigned short dtl,err;
	unsigned short n,c,h,r;

	n=(para->n); c=(para->c);
	h=(para->h); r=(para->r);
	dtl=(128<<n);

	// int86x()łȂCCAZuȂ̂
	// union REGS  BPڼ޽ 
	_asm{
		pushf
		push ax
		push bx
		push cx
		push dx
		push es
		push bp

		mov ah,cmnd
		mov al,daua
		mov bx,dtl
		mov ch,n
		mov cl,c
		mov dh,h
		mov dl,r
		les bp,buff
		int 1bh
		mov al,0
		rcl al,1

		pop bp
		pop es
		mov err,ax
		pop dx
		pop cx
		pop bx
		pop ax
		popf
	}

	if(err&15) err>>=8;
	else       err  =0;

	return err;
}

void main(int argc,unsigned char *argv[])
{
	static short Retry=2;
	static short drive=0;
	struct FDD_PARA para;
	unsigned char *fname;
	unsigned char far *buff;
	unsigned short seg,daua;
	short i,f,cnt;
	short key,err;
	int fh,fc;
	union REGS reg;

	err=0; fname=NULL;
	for(i=1; i<argc && !err; i++){
		if(argv[i][0]=='-' || argv[i][0]=='/'){
			if((argv[i][1]|0x20)=='r'){
				if(sscanf(&argv[i][2],"%d",&Retry)!=1) err=1;
			} else {
				f=argv[i][1];
				if(f>='0' && f<='3') drive=(f-'0');
				else err=1;
			}
		} else {
			if(fname==NULL) fname=argv[i];
			else err=1;
		}
	}
	if(err || fname==NULL){
		printf("l`jdQc <Ver 0.2C>\n");
		printf("  Qctbs[̃C[Wt@C쐬܂\n");
		printf("  ̃vO͂obXWV[Ypł\n");
		printf("gp@\n");
		printf("  MAKE2D </n> </Rn> [2DҰ]\n");
		printf("2DҰ\n");
		printf("  C[Wt@C̃t@C\n");
		printf("/n\n");
		printf("  n=ǂݍ݃hCuio[  (Default=/0)\n");
		printf("/Rn\n");
		printf("  [hG[̃gC(Default=/R2)\n");
		exit(1);
	}

	printf("\n");
	printf("*** ̃vO͂obXWV[Ypł ***\n");
	printf("\n");
	printf("Pڂ̃tbs[hCuɂQctbs[ĉ\n");
	printf("o牽L[ĉ (ESC:f)\n");
	while( kbhit()) getch();
	while(!kbhit());
	while( kbhit()) key=getch();
	printf("\n");

	if(key==0x1b){
		printf("***** ~܂ *****\n");
		exit(1);
	}

	// FddBios64KByteE܂œǂݏoȂ
	_dos_allocmem(0x2002,&seg);
	FP_SEG(buff)=(seg&0xf000)+0x1000;
	FP_OFF(buff)=0;

	reg.h.ah=0x8e; // Ӱނ̎w
	reg.h.al=0x1f; // bit0-3 0=48tpi 1=96tpi
	reg.h.al^=(1<<drive);
	int86(0x1b,&reg,&reg);

	// DA/UA
	daua=0x10|drive;

	// 2D
	para.n=1; //   1=256
	para.c=0; // No. 0-39
	para.h=0; // ͯ     0-1 
	para.r=1; // No.   1-16

	cnt=key=0; Retry++;
	err=_dos_creat(argv[1],0,&fh)?1:0;
	for(para.c=0; para.c<=39 && !err; para.c++){
		for(para.h=0; para.h<=1 && !err; para.h++){
			i =(short)(para.c)*2;
			i+=(short)(para.h);
			printf("TRK:%02d/80 ",i);
			for(para.r=1; para.r<=16 && !err; para.r++){
				if(kbhit()){
					while(kbhit()) key=getch();
					if(key==0x1b){ err=2; break; }
				}
				for(i=0; i<Retry; i++){
					f=BiosRead(0x56,daua,&para,buff)?1:0;
					if(!f) break;
				}
				if(!f){
					printf("o");
				} else {
					printf("x"); cnt++;
				}
				err=_dos_write(fh,buff,256,&fc)?1:0;
			}
			printf(" ");
		}
		printf("\n");
		if(err) break;
	}
	_dos_close(fh);

	_dos_freemem(seg);

	reg.h.ah=0x8e; // Ӱނ̎w
	reg.h.al=0x1f; // unit0-3 <- 96tpi
	int86(0x1b,&reg,&reg);

	if(       err==1){
		printf("***** ݂ŃG[܂ *****\n");
	} else if(err==2){
		printf("***** ~܂ *****\n");
	} else {
		printf("ǍݕsǃZN^:%d\n",cnt);
		printf("OK.\n");
	}
}

