#include <dos.h>
#include <io.h>
#include "graph.h"

static void _atrAT(short num,short pal)
{
	_disable();

	inp(0x3da);
	outp(0x3c0,num);
	outp(0x3c0,pal);

	inp(0x3da);
	outp(0x3c0,0x20); // reset

	_enable();
}

// 
void GrpInitAT(void)
{
	union REGS reg;
	short i,r,g,b;

	// SCREEN_MODE 12H (640*480 16Color)
	reg.x.ax=0x12; int86(0x10,&reg,&reg);
	for(i=0; i<16; i++) _atrAT(i,i);
	for(i=0; i<16; i++) GrpPalAT(i,(i&4?15:0),(i&2?15:0),(i&1?15:0));
	outpw(0x03ce,0x0005); // ݃[hO
	outpw(0x03ce,0x0001); // SET/RESETgp
	outpw(0x03ce,0xff08); // ޯĥϽ=ffH
	outpw(0x03ce,0x0003); // ްײ

	GrpClsAT();
}

// I
void GrpTermAT(void)
{
	static short pal[]={ 0,1,2,3,4,5,20,7,56,57,58,59,60,61,62,63 };
	union REGS reg;
	short i;

	GrpClsAT();
	for(i=0; i<16; i++) _atrAT(i,pal[i]);

	reg.x.ax=0x03;
	int86(0x10,&reg,&reg);
}

// ʃNA
void mem_clrAT(unsigned short seg,unsigned short lng)
{
	char far *buf;
	FP_SEG(buf)=seg;
	FP_OFF(buf)=0;
	while(lng--) (*buf++)=0;
}

void GrpClsAT(void)
{
	outpw(0x03c4,0x0102); mem_clrAT(0xa000,0x9600); // ڰ 1
	outpw(0x03c4,0x0202); mem_clrAT(0xa000,0x9600); // ڰ 2
	outpw(0x03c4,0x0402); mem_clrAT(0xa000,0x9600); // ڰ 3
	outpw(0x03c4,0x0802); mem_clrAT(0xa000,0x9600); // ڰ 4
}

// pbg
void GrpPalAT(int n,int g,int r,int b)
{
	r<<=2; if(r) r|=3;
	g<<=2; if(g) g|=3;
	b<<=2; if(b) b|=3;

	_disable();
	outp(0x3c8,n); outp(0x3c9,r);
	outp(0x3c9,g); outp(0x3c9,b);
	_enable();
}

// `mj \
void PutAnkAT(short x,short y,short col,unsigned char *buff)
{
	static unsigned short tbl[]={ 0x0102,0x0202,0x0402,0x0802 };
	unsigned char far *vrm;
	short i,n,pag;

	for(pag=0; pag<4; pag++){
		outpw(0x03c4,tbl[pag]);
		FP_SEG(vrm)=0xa000;
		FP_OFF(vrm)=(y*16*80)+x;
		for(i=n=0; i<16; i++){
			if(col&1) vrm[0]=buff[n++];
			else      vrm[0]=0;
			FP_SEG(vrm)+=5;
		}
		col>>=1;
	}
}

//  \
void PutKnjAT(short x,short y,short col,unsigned char *buff)
{
	static unsigned short tbl[]={ 0x0102,0x0202,0x0402,0x0802 };
	unsigned char far *vrm;
	short i,n,pag;

	for(pag=0; pag<4; pag++){
		outpw(0x03c4,tbl[pag]);
		FP_SEG(vrm)=0xa000;
		FP_OFF(vrm)=(y*16*80)+x;
		for(i=n=0; i<16; i++){
			if(col&1){ vrm[0]=buff[n++]; vrm[1]=buff[n++]; }
			else{      vrm[0]=0; vrm[1]=0; }
			FP_SEG(vrm)+=5;
		}
		col>>=1;
	}
}

// tHgp^[̎擾
// code  0x00nn=1/4  0x80nn=ANK  0xnnnn=SHIFT-JIS
void GetFntAT(unsigned short code,unsigned char far *buff)
{
	union REGS r;
	struct SREGS s;
	unsigned short xl,yl,sjis;
	unsigned short i,n;
	unsigned char tmp[32];

	sjis=code;
	if((code>>8)==0x80) sjis&=0xff;

	if(!(sjis&0xff00)){ xl= 8; yl=16; }
	else{               xl=16; yl=16; }

	segread(&s);
	r.h.ah=0x18;
	r.h.al=0; // 0=read 1=write
	r.x.bx=0; // Ӽ޾=0
	r.x.cx=sjis;
	r.h.dh=xl;
	r.h.dl=yl;
	r.x.si=FP_OFF(buff);
	s.es  =FP_SEG(buff);
	int86x(0x10,&r,&r,&s);

	if(!(code>>8)){
		for(i=n=0; i<8; i++){
			tmp[i] =buff[n++];
			tmp[i]|=buff[n++];
		}
		for(i=0; i< 8; i++) buff[i]=tmp[i];
		for(i=8; i<16; i++) buff[i]=0xff;
	}
}

