#include <stdio.h>
#include <string.h>
#include <io.h>
#include <i86.h>
#include <dos.h>
#include <fcntl.h>
#include "x1.h"
#include "x1_opm.h"
#include "joypad.h"
#include "msdos.h"

void tcnt_set_98(short cnt);
void tcnt_set_at(short cnt);
short tcnt_get_98(void);
short tcnt_get_at(void);
void timer_ini_98(long rate);
void timer_ini_at(long rate);
void timer_end_98(void);
void timer_end_at(void);

void kb_init_98(void);
void kb_init_at(void);
void kb_reset_98(void);
void kb_reset_at(void);
short key_int_chk_98(void);
short key_int_chk_at(void);
void key_int_clr_98(void);
void key_int_clr_at(void);
void key_get_98(byte *sft,byte *chr);
void key_get_at(byte *sft,byte *chr);
void game_key_98(byte *tbl);
void game_key_at(byte *tbl);
void exkey_98(void);
void exkey_at(void);

short v_blank_98(void);
short v_blank_at(void);
void palet_98(int n,int g,int r,int b);
void palet_at(int n,int g,int r,int b);
void put_line_98(word x,word y,word l,struct GPTN *ptn);
void put_line_at(word x,word y,word l,struct GPTN *ptn);
void put_font_98(short x,short y,struct GPTN *ptn);
void put_font_at(short x,short y,struct GPTN *ptn);
void put88_98(short x,short y,struct GPTN *ptn);
void put88_at(short x,short y,struct GPTN *ptn);

word init_98(void);
word init_at(void);
void term_98(void);
void term_at(void);

/**********************************************************************
	^C}[
**********************************************************************/

void tcnt_set(short cnt)
{
	if(PC98FLG) tcnt_set_98(cnt);
	else        tcnt_set_at(cnt);
}

short tcnt_get(void)
{
	if(PC98FLG) return tcnt_get_98();
	return tcnt_get_at();
}

void timer_ini(long rate)
{
	if(PC98FLG) timer_ini_98(rate);
	else        timer_ini_at(rate);
}

void timer_end(void)
{
	if(PC98FLG) timer_end_98();
	else        timer_end_at();
}

/**********************************************************************
	L[{[h
**********************************************************************/

void kb_init(void)
{
	if(PC98FLG) kb_init_98();
	else        kb_init_at();
}

void kb_reset(void)
{
	if(PC98FLG) kb_reset_98();
	else        kb_reset_at();
}

short key_int_chk(void)
{
	if(PC98FLG) return key_int_chk_98();
	return key_int_chk_at();
}

void key_int_clr(void)
{
	if(PC98FLG) key_int_clr_98();
	else        key_int_clr_at();
}

void key_get_x1(byte *sft,byte *chr)
{
	if(PC98FLG) key_get_98(sft,chr);
	else        key_get_at(sft,chr);
}

void game_key_x1(byte *tbl)
{
	if(PC98FLG) game_key_98(tbl);
	else        game_key_at(tbl);
}

void exkey_x1(void)
{
	if(PC98FLG) exkey_98();
	else        exkey_at();
}

/***********************************************************************
	
***********************************************************************/

short v_blank(void)
{
	if(PC98FLG) return v_blank_98();
	return v_blank_at();
}

void palet(int n,int g,int r,int b)
{
	if(PC98FLG) palet_98(n,g,r,b);
	else        palet_at(n,g,r,b);
}

void put_line(word x,word y,word l,struct GPTN *ptn)
{
	if(PC98FLG) put_line_98(x,y,l,ptn);
	else        put_line_at(x,y,l,ptn);
}

void put_font(short x,short y,struct GPTN *ptn)
{
	if(PC98FLG) put_font_98(x,y,ptn);
	else        put_font_at(x,y,ptn);
}

void put88(short x,short y,struct GPTN *ptn)
{
	if(PC98FLG) put88_98(x,y,ptn);
	else        put88_at(x,y,ptn);
}

/***********************************************************************
	}EX
***********************************************************************/

word mouse_ini(void)
{
	union REGS r;

	r.w.ax=0;
	int386(0x33,&r,&r);

	return r.w.ax;
}

short mouse_get(short *x,short *y)
{
	union REGS r;

	r.w.ax=11;
	int386(0x33,&r,&r);
	(*x)=r.w.cx;
	(*y)=r.w.dx;

	r.w.ax=5;
	r.w.bx=0;
	int386(0x33,&r,&r);

	return (r.w.ax&3);
}

/***********************************************************************
	
***********************************************************************/

word init_machine(void)
{
	short ans;

	mouse_ini();
	pad_ini();

	opm_trace_end();
	x1_psg_ini();
	x1_opm_ini();

	if(PC98FLG) ans=init_98();
	else        ans=init_at();

	return ans;
}

void term_machine(void)
{
	opm_trace_end();
	x1_psg_end();
	x1_opm_end();

	pad_end();

	if(PC98FLG) term_98();
	else        term_at();
}

